    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * --------------------------------------------
    028 * DynamicDriveToolTipTagFragmentGenerator.java
    029 * --------------------------------------------
    030 * (C) Copyright 2003-2009, by Richard Atkinson and Contributors.
    031 *
    032 * Original Author:  Richard Atkinson;
    033 * Contributors:     David Gilbert (for Object Refinery Limited);
    034 *                   Fawad Halim - bug 2690293;
    035 *
    036 * Changes
    037 * -------
    038 * 12-Aug-2003 : Version 1 (RA);
    039 * 04-Dec-2007 : Escape tool tip text to fix bug 1400917 (DG);
    040 * 19-Mar-2009 : Escape apostrophes - see bug 2690293 with fix by FH (DG);
    041 *
    042 */
    043
    044package org.jfree.chart.imagemap;
    045
    046/**
    047 * Generates tooltips using the Dynamic Drive DHTML Tip Message
    048 * library (http://www.dynamicdrive.com).
    049 */
    050public class DynamicDriveToolTipTagFragmentGenerator
    051        implements ToolTipTagFragmentGenerator {
    052
    053    /** The title, empty string not to display */
    054    protected String title = "";
    055
    056    /** The style number */
    057    protected int style = 1;
    058
    059    /**
    060     * Blank constructor.
    061     */
    062    public DynamicDriveToolTipTagFragmentGenerator() {
    063        super();
    064    }
    065
    066    /**
    067     * Creates a new generator with specific title and style settings.
    068     *
    069     * @param title  title for use in all tooltips, use empty String not to
    070     *               display a title.
    071     * @param style  style number, see http://www.dynamicdrive.com for more
    072     *               information.
    073     */
    074    public DynamicDriveToolTipTagFragmentGenerator(String title, int style) {
    075        this.title = title;
    076        this.style = style;
    077    }
    078
    079    /**
    080     * Generates a tooltip string to go in an HTML image map.
    081     *
    082     * @param toolTipText  the tooltip.
    083     *
    084     * @return The formatted HTML area tag attribute(s).
    085     */
    086    public String generateToolTipFragment(String toolTipText) {
    087        return " onMouseOver=\"return stm(['"
    088            + ImageMapUtilities.javascriptEscape(this.title) + "','"
    089            + ImageMapUtilities.javascriptEscape(toolTipText) + "'],Style["
    090            + this.style + "]);\"" + " onMouseOut=\"return htm();\"";
    091    }
    092
    093}